



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Java代码规范</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Java代码规范</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-05 03:13:57 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>Java</strong><strong>代码规范</strong></p>
<p>本Java代码规范以SUN的标准Java代码规范为基础，为适应我们公司的实际需要，可能会做一些修改。本文档中没有说明的地方，请参看SUN Java标准代码规范。如果两边有冲突，以SUN Java标准为准。</p>
<p><strong>1.&nbsp;</strong><strong>标识符命名规范</strong></p>
<p><strong>1.1&nbsp;</strong><strong>概述</strong></p>
<p>标识符的命名力求做到统一、达意和简洁。</p>
<p><strong>1.1.1&nbsp;</strong><strong>统一</strong></p>
<p>统一是指，对于同一个概念，在程序中用同一种表示方法，比如对于供应商，既可以用supplier，也可以用provider，但是我们只能选定一个使用，至少在一个Java项目中保持统一。统一是作为重要的，如果对同一概念有不同的表示方法，会使代码混乱难以理解。即使不能取得好的名称，但是只要统一，阅读起来也不会太困难，因为阅读者只要理解一次。</p>
<p><strong>1.1.2&nbsp;</strong><strong>达意</strong></p>
<p>达意是指，标识符能准确的表达出它所代表的意义，比如：&nbsp;newSupplier, OrderPaymentGatewayService等；而&nbsp;supplier1, service2，idtts等则不是好的命名方式。准确有两成含义，一是正确，而是丰富。如果给一个代表供应商的变量起名是&nbsp;order，显然没有正确表达。同样的，supplier1,&nbsp;远没有targetSupplier意义丰富。.</p>
<p><strong>1.1.3&nbsp;</strong><strong>简洁</strong></p>
<p>简洁是指，在统一和达意的前提下，用尽量少的标识符。如果不能达意，宁愿不要简洁。比如：theOrderNameOfTheTargetSupplierWhichIsTransfered&nbsp;太长，&nbsp;transferedTargetSupplierOrderName则较好，但是transTgtSplOrdNm就不好了。省略元音的缩写方式不要使用，我们的英语往往还没有好到看得懂奇怪的缩写。</p>
<p><strong>1.1.4&nbsp;</strong><strong>骆驼法则</strong></p>
<p>Java中，除了包名，静态常量等特殊情况，大部分情况下标识符使用骆驼法则，即单词之间不使用特殊符号分割，而是通过首字母大写来分割。比如: supplierName, addNewContract，而不是&nbsp;supplier_name, add_new_contract。</p>
<p><strong>1.1.5&nbsp;</strong><strong>英文</strong><strong>&nbsp;vs&nbsp;</strong><strong>拼音</strong></p>
<p>尽量使用通俗易懂的英文单词，如果不会可以向队友求助，实在不行则使用汉语拼音，避免拼音与英文混用。比如表示归档，用archive比较好,&nbsp;用pigeonhole则不好，用guiDang尚可接受。</p>
<p><strong>1.2&nbsp;</strong><strong>包名</strong></p>
<p>使用小写字母如&nbsp;com.xxx.settlment，不要&nbsp;com.xxx.Settlement<br />单词间不要用字符隔开，比如&nbsp;com.xxx.settlment.jsfutil，而不要com.xxx.settlement.jsf_util</p>
<p><strong>1.3&nbsp;</strong><strong>类名</strong></p>
<p><strong>1.3.1&nbsp;</strong><strong>首字母大写</strong></p>
<p>类名要首字母大写，比如&nbsp;SupplierService, PaymentOrderAction；不要&nbsp;supplierService, paymentOrderAction.</p>
<p><strong>1.3.2&nbsp;</strong><strong>后缀</strong></p>
<p>类名往往用不同的后缀表达额外的意思，如下表：</p>
<table>
<tbody>
<tr>
<td>
<p>后缀名</p>
</td>
<td>
<p>意义</p>
</td>
<td>
<p>举例</p>
</td>
</tr>
<tr>
<td>
<p>Service</p>
</td>
<td>
<p>表明这个类是个服务类，里面包含了给其他类提同业务服务的方法</p>
</td>
<td>
<p>PaymentOrderService</p>
</td>
</tr>
<tr>
<td>
<p>Impl</p>
</td>
<td>
<p>这个类是一个实现类，而不是接口</p>
</td>
<td>
<p>PaymentOrderServiceImpl</p>
</td>
</tr>
<tr>
<td>
<p>Dao</p>
</td>
<td>
<p>这个类封装了数据访问方法</p>
</td>
<td>
<p>PaymentOrderDao</p>
</td>
</tr>
<tr>
<td>
<p>Action</p>
</td>
<td>
<p>直接处理页面请求，管理页面逻辑了类</p>
</td>
<td>
<p>UpdateOrderListAction</p>
</td>
</tr>
<tr>
<td>
<p>Listener</p>
</td>
<td>
<p>响应某种事件的类</p>
</td>
<td>
<p>PaymentSuccessListener</p>
</td>
</tr>
<tr>
<td>
<p>Event</p>
</td>
<td>
<p>这个类代表了某种事件</p>
</td>
<td>
<p>PaymentSuccessEvent</p>
</td>
</tr>
<tr>
<td>
<p>Servlet</p>
</td>
<td>
<p>一个Servlet</p>
</td>
<td>
<p>PaymentCallbackServlet</p>
</td>
</tr>
<tr>
<td>
<p>Factory</p>
</td>
<td>
<p>生成某种对象工厂的类</p>
</td>
<td>
<p>PaymentOrderFactory</p>
</td>
</tr>
<tr>
<td>
<p>Adapter</p>
</td>
<td>
<p>用来连接某种以前不被支持的对象的类</p>
</td>
<td>
<p>DatabaseLogAdapter</p>
</td>
</tr>
<tr>
<td>
<p>Job</p>
</td>
<td>
<p>某种按时间运行的任务</p>
</td>
<td>
<p>PaymentOrderCancelJob</p>
</td>
</tr>
<tr>
<td>
<p>Wrapper</p>
</td>
<td>
<p>这是一个包装类，为了给某个类提供没有的能力</p>
</td>
<td>
<p>SelectableOrderListWrapper</p>
</td>
</tr>
<tr>
<td>
<p>Bean</p>
</td>
<td>
<p>这是一个POJO</p>
</td>
<td>
<p>MenuStateBean</p>
</td>
</tr>
</tbody>
</table>
<p><strong>1.4&nbsp;</strong><strong>方法名</strong></p>
<p>首字母小写，如&nbsp;addOrder()&nbsp;不要&nbsp;AddOrder()<br />动词在前，如&nbsp;addOrder()，不要orderAdd()<br />动词前缀往往表达特定的含义，如下表：</p>
<table>
<tbody>
<tr>
<td>
<p>前缀名</p>
</td>
<td>
<p>意义</p>
</td>
<td>
<p>举例</p>
</td>
</tr>
<tr>
<td>
<p>create</p>
</td>
<td>
<p>创建</p>
</td>
<td>
<p>createOrder()</p>
</td>
</tr>
<tr>
<td>
<p>delete</p>
</td>
<td>
<p>删除</p>
</td>
<td>
<p>deleteOrder()</p>
</td>
</tr>
<tr>
<td>
<p>add</p>
</td>
<td>
<p>创建，暗示新创建的对象属于某个集合</p>
</td>
<td>
<p>addPaidOrder()</p>
</td>
</tr>
<tr>
<td>
<p>remove</p>
</td>
<td>
<p>删除</p>
</td>
<td>
<p>removeOrder()</p>
</td>
</tr>
<tr>
<td>
<p>init或则initialize</p>
</td>
<td>
<p>初始化，暗示会做些诸如获取资源等特殊动作</p>
</td>
<td>
<p>initializeObjectPool</p>
</td>
</tr>
<tr>
<td>
<p>destroy</p>
</td>
<td>
<p>销毁，暗示会做些诸如释放资源的特殊动作</p>
</td>
<td>
<p>destroyObjectPool</p>
</td>
</tr>
<tr>
<td>
<p>open</p>
</td>
<td>
<p>打开</p>
</td>
<td>
<p>openConnection()</p>
</td>
</tr>
<tr>
<td>
<p>close</p>
</td>
<td>
<p>关闭</p>
</td>
<td>
<p>closeConnection()&lt;</p>
</td>
</tr>
<tr>
<td>
<p>read</p>
</td>
<td>
<p>读取</p>
</td>
<td>
<p>readUserName()</p>
</td>
</tr>
<tr>
<td>
<p>write</p>
</td>
<td>
<p>写入</p>
</td>
<td>
<p>writeUserName()</p>
</td>
</tr>
<tr>
<td>
<p>get</p>
</td>
<td>
<p>获得</p>
</td>
<td>
<p>getName()</p>
</td>
</tr>
<tr>
<td>
<p>set</p>
</td>
<td>
<p>设置</p>
</td>
<td>
<p>setName()</p>
</td>
</tr>
<tr>
<td>
<p>prepare</p>
</td>
<td>
<p>准备</p>
</td>
<td>
<p>prepareOrderList()</p>
</td>
</tr>
<tr>
<td>
<p>copy</p>
</td>
<td>
<p>复制</p>
</td>
<td>
<p>copyCustomerList()</p>
</td>
</tr>
<tr>
<td>
<p>modity</p>
</td>
<td>
<p>修改</p>
</td>
<td>
<p>modifyActualTotalAmount()</p>
</td>
</tr>
<tr>
<td>
<p>calculate</p>
</td>
<td>
<p>数值计算</p>
</td>
<td>
<p>calculateCommission()</p>
</td>
</tr>
<tr>
<td>
<p>do</p>
</td>
<td>
<p>执行某个过程或流程</p>
</td>
<td>
<p>doOrderCancelJob()</p>
</td>
</tr>
<tr>
<td>
<p>dispatch</p>
</td>
<td>
<p>判断程序流程转向</p>
</td>
<td>
<p>dispatchUserRequest()</p>
</td>
</tr>
<tr>
<td>
<p>start</p>
</td>
<td>
<p>开始</p>
</td>
<td>
<p>startOrderProcessing()</p>
</td>
</tr>
<tr>
<td>
<p>stop</p>
</td>
<td>
<p>结束</p>
</td>
<td>
<p>stopOrderProcessing()</p>
</td>
</tr>
<tr>
<td>
<p>send</p>
</td>
<td>
<p>发送某个消息或事件</p>
</td>
<td>
<p>sendOrderPaidMessage()</p>
</td>
</tr>
<tr>
<td>
<p>receive</p>
</td>
<td>
<p>接受消息或时间</p>
</td>
<td>
<p>receiveOrderPaidMessgae()</p>
</td>
</tr>
<tr>
<td>
<p>respond</p>
</td>
<td>
<p>响应用户动作</p>
</td>
<td>
<p>responseOrderListItemClicked()</p>
</td>
</tr>
<tr>
<td>
<p>find</p>
</td>
<td>
<p>查找对象</p>
</td>
<td>
<p>findNewSupplier()</p>
</td>
</tr>
<tr>
<td>
<p>update</p>
</td>
<td>
<p>更新对象</p>
</td>
<td>
<p>updateCommission()</p>
</td>
</tr>
</tbody>
</table>
<p>find方法在业务层尽量表达业务含义，比如&nbsp;findUnsettledOrders()，查询未结算订单，而不要findOrdersByStatus()。&nbsp;数据访问层，find,update等方法可以表达要执行的sql，比如findByStatusAndSupplierIdOrderByName(Status.PAID, 345)</p>
<p><strong>1.5&nbsp;</strong><strong>域（</strong><strong>field</strong><strong>）名</strong></p>
<p><strong>1.5.1&nbsp;</strong><strong>静态常量</strong></p>
<p>全大写用下划线分割，如</p>
<p>public static find String ORDER_PAID_EVENT = &ldquo;ORDER_PAID_EVENT&rdquo;;</p>
<p><strong>1.5.2&nbsp;</strong><strong>枚举</strong></p>
<p>全大写，用下划线分割，如</p>
<p>public enum Events {<br />ORDER_PAID,<br />ORDER_CREATED<br />}</p>
<p><strong>1.5.3&nbsp;</strong><strong>其他</strong></p>
<p><strong>首字母小写，骆驼法则，如：</strong></p>
<p><strong>public String orderName;</strong></p>
<p><strong>1.6&nbsp;</strong><strong>局部变量名</strong></p>
<p>参数和局部变量名首字母小写，骆驼法则。尽量不要和域冲突，尽量表达这个变量在方法中的意义。</p>
<p><strong>2.&nbsp;</strong><strong>代码格式</strong></p>
<p>用空格字符缩进源代码，不要用tab，每个缩进4个空格。</p>
<p><strong>2.1&nbsp;</strong><strong>源文件编码</strong></p>
<p>源文件使用utf-8编码，结尾用unix n&nbsp;分格。</p>
<p><strong>2.2&nbsp;</strong><strong>行宽</strong></p>
<p>行宽度不要超过80。Eclipse标准</p>
<p><strong>2.3&nbsp;</strong><strong>包的导入</strong></p>
<p>删除不用的导入，尽量不要使用整个包的导入。在eclipse下经常使用快捷键&nbsp;ctrl+shift+o&nbsp;修正导入。</p>
<p><strong>2.4&nbsp;</strong><strong>类格式</strong></p>
<p><strong>2.5&nbsp;</strong><strong>域格式</strong></p>
<p>每行只能声明一个域。<br />域的声明用空行隔开。</p>
<p><strong>2.5&nbsp;</strong><strong>方法格式</strong></p>
<p><strong>2.6&nbsp;</strong><strong>代码块格式</strong></p>
<p><strong>2.6.1&nbsp;</strong><strong>缩进风格</strong></p>
<p>大括号的开始在代码块开始的行尾，闭合在和代码块同一缩进的行首，例如：</p>
<p><strong>package</strong>&nbsp;com.test;</p>
<p><strong>public</strong>&nbsp;<strong>class</strong>&nbsp;TestStyle&nbsp;<strong>extends</strong>&nbsp;SomeClass&nbsp;<strong>implements</strong>&nbsp;AppleInter, BananaInter&nbsp;{</p>
<p><strong>public</strong>&nbsp;<strong>static</strong>&nbsp;<strong>final</strong>&nbsp;String&nbsp;THIS_IS_CONST&nbsp;=&nbsp;"CONST VALUE";</p>
<p><strong>private</strong>&nbsp;<strong>static</strong>&nbsp;<strong>void</strong>&nbsp;main(String[]&nbsp;args)&nbsp;{</p>
<p><strong>int</strong>&nbsp;localVariable&nbsp;=&nbsp;0;</p>
<p>}</p>
<p><strong>public</strong>&nbsp;<strong>void</strong>&nbsp;compute(String&nbsp;arg)&nbsp;{</p>
<p><strong>if</strong>&nbsp;(arg.length()&nbsp;&gt;&nbsp;&nbsp;0)&nbsp;{</p>
<p>System.out.println(arg);</p>
<p>}</p>
<p><strong>for</strong>&nbsp;(<strong>int</strong>&nbsp;i&nbsp;=&nbsp;0;&nbsp;i&nbsp;&lt;&nbsp;10;&nbsp;i++)&nbsp;{</p>
<p>System.out.println(arg);</p>
<p>}</p>
<p><strong>while</strong>&nbsp;(condition)&nbsp;{</p>
<p>}</p>
<p><strong>do</strong>&nbsp;{</p>
<p>otherMethod();</p>
<p>}&nbsp;<strong>while</strong>&nbsp;(condition);</p>
<p><strong>switch</strong>&nbsp;(i)&nbsp;{</p>
<p><strong>case</strong>&nbsp;0:</p>
<p>callFunction();</p>
<p><strong>break</strong>;</p>
<p><strong>case</strong>&nbsp;1:</p>
<p>callFunctionb();</p>
<p><strong>break</strong>;</p>
<p><strong>default</strong>:</p>
<p><strong>break</strong>;</p>
<p>}</p>
<p>}</p>
<p>}</p>
<p><strong>2.6.2&nbsp;</strong><strong>空格的使用</strong></p>
<p><strong>2.6.2.1&nbsp;</strong><strong>表示分割时用一个空格</strong></p>
<p>不能这样：</p>
<p><strong>if</strong>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;(&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; a&nbsp;&gt;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; b&nbsp;&nbsp;&nbsp;)&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;{</p>
<p><em>//do something here</em></p>
<p>};</p>
<p><strong>2.6.2.2&nbsp;</strong><strong>二元三元运算符两边用一个空格隔开</strong></p>
<p>如下：</p>
<p>a&nbsp;+&nbsp;b&nbsp;=&nbsp;c;</p>
<p>b&nbsp;-&nbsp;d&nbsp;=&nbsp;e;</p>
<p><strong>return</strong>&nbsp;a&nbsp;==&nbsp;b&nbsp;?&nbsp;1&nbsp;:&nbsp;0;</p>
<p>不能如下：</p>
<p>a+b=c;</p>
<p>b-d=e;</p>
<p><strong>return</strong>&nbsp;a==b?1:0;</p>
<p><strong>2.6.2.3&nbsp;</strong><strong>逗号语句后如不还行，紧跟一个空格</strong></p>
<p>如下：</p>
<p>call(a, b, c);</p>
<p>不能如下：</p>
<p>call(a,b,c);</p>
<p><strong>2.6.3&nbsp;</strong><strong>空行的使用</strong></p>
<p>空行可以表达代码在语义上的分割，注释的作用范围，等等。将类似操作，或一组操作放在一起不用空行隔开，而用空行隔开不同组的代码，&nbsp;如图：</p>
<p>order&nbsp;=&nbsp;orderDao.findOrderById(id);</p>
<p><em>//update properties</em></p>
<p>order.setUserName(userName);</p>
<p>order.setPrice(456);</p>
<p>order.setStatus(PAID);</p>
<p>orderService.updateTotalAmount(order);</p>
<p>session.saveOrUpdate(order);</p>
<p>上例中的空行，使注释的作用域很明显.</p>
<ul><li>连续两行的空行代表更大的语义分割。</li>
<li>方法之间用空行分割</li>
<li>域之间用空行分割</li>
<li>超过十行的代码如果还不用空行分割，就会增加阅读困难</li></ul>
<p><strong>3.&nbsp;</strong><strong>注释规范</strong></p>
<p><strong>3.1&nbsp;</strong><strong>注释</strong><strong>&nbsp;vs&nbsp;</strong><strong>代码</strong></p>
<ul><li>注释宜少二精，不宜多而滥，更不能误导</li>
<li>命名达意，结构清晰，&nbsp;类和方法等责任明确，往往不需要，或者只需要很少注释，就可以让人读懂；相反，代码混乱，再多的注释都不能弥补。所以，应当先在代码本身下功夫。</li>
<li>不能正确表达代码意义的注释，只会损害代码的可读性。</li>
<li>过于详细的注释，对显而易见的代码添加的注释，罗嗦的注释，还不如不写。</li>
<li>注释要和代码同步，过多的注释会成为开发的负担</li>
<li>注释不是用来管理代码版本的，如果有代码不要了，直接删除，svn会有记录的，不要注释掉，否则以后没人知道那段注释掉的代码该不该删除。</li></ul>
<p><strong>3.2 Java Doc</strong></p>
<p>表明类、域和方法等的意义和用法等的注释，要以javadoc的方式来写。Java Doc是个类的使用者来看的，主要介绍&nbsp;是什么，怎么用等信息。凡是类的使用者需要知道，都要用Java Doc&nbsp;来写。非Java Doc的注释，往往是个代码的维护者看的，着重告述读者为什么这样写，如何修改，注意什么问题等。&nbsp;如下：</p>
<p><strong><em>/**</em></strong></p>
<p><strong><em>* This is a class comment</em></strong></p>
<p><strong><em>*/</em></strong></p>
<p><strong>public</strong>&nbsp;<strong>class</strong>&nbsp;TestClass&nbsp;{</p>
<p><strong><em>/**</em></strong></p>
<p><strong><em>&nbsp;&nbsp;&nbsp; * This is a field comment</em></strong></p>
<p><strong><em>&nbsp;&nbsp;&nbsp; */</em></strong></p>
<p><strong>public</strong>&nbsp;String&nbsp;name;</p>
<p><strong><em>/**</em></strong></p>
<p><strong><em>&nbsp;&nbsp;&nbsp; * This is a method comment</em></strong></p>
<p><strong><em>&nbsp;&nbsp;&nbsp; */</em></strong></p>
<p><strong>public</strong>&nbsp;<strong>void</strong>&nbsp;call()&nbsp;{</p>
<p>}</p>
<p>}</p>
<p><strong>3.3&nbsp;</strong><strong>块级别注释</strong></p>
<p><strong>3.3.1&nbsp;</strong><strong>块级别注释，单行时用</strong><strong>&nbsp;//,&nbsp;</strong><strong>多行时用</strong><strong>&nbsp;/* .. */</strong><strong>。</strong></p>
<p><strong>3.3.2&nbsp;</strong><strong>较短的代码块用空行表示注释作用域</strong></p>
<p><strong>3.3.3&nbsp;</strong><strong>较长的代码块要用</strong></p>
<p><em>/*------ start: ------*/</em></p>
<p>和</p>
<p><em>/*-------- end: -------*/</em></p>
<p>包围<br />如：</p>
<p><em>/*----------start:&nbsp;</em><em>订单处理</em><em>&nbsp;------- */</em></p>
<p><em>//</em><em>取得</em><em>dao</em></p>
<p>OrderDao dao&nbsp;=&nbsp;Factory.getDao("OrderDao");</p>
<p><em>/*&nbsp;</em><em>查询订单</em><em>&nbsp;*/</em></p>
<p>Order order&nbsp;=&nbsp;dao.findById(456);</p>
<p><em>//</em><em>更新订单</em></p>
<p>order.setUserName("uu");</p>
<p>order.setPassword("pass");</p>
<p>order.setPrice("ddd");</p>
<p>orderDao.save(order);</p>
<p><em>/*----------end:&nbsp;</em><em>订单处理</em><em>&nbsp;------- */</em></p>
<p><strong>3.3.4&nbsp;</strong><strong>可以考虑使用大括号来表示注释范围</strong></p>
<p>使用大括号表示注释作用范围的例子：</p>
<p><em>/*----------</em><em>订单处理</em><em>&nbsp;------- */</em></p>
<p>{</p>
<p><em>//</em><em>取得</em><em>dao</em></p>
<p>OrderDao dao&nbsp;=&nbsp;Factory.getDao("OrderDao");</p>
<p><em>/*&nbsp;</em><em>查询订单</em><em>&nbsp;*/</em></p>
<p>Order order&nbsp;=&nbsp;dao.findById(456);</p>
<p><em>//</em><em>更新订单</em></p>
<p>order.setUserName("uu");</p>
<p>order.setPassword("pass");</p>
<p>order.setPrice("ddd");</p>
<p>orderDao.save(order);</p>
<p>}</p>
<p><strong>3.4&nbsp;</strong><strong>行内注释</strong></p>
<p>行内注释用&nbsp;//&nbsp;写在行尾</p>
<p><strong>4&nbsp;</strong><strong>最佳实践和禁忌</strong></p>
<p><strong>4.1&nbsp;</strong><strong>每次保存的时候，都让你的代码是最美的</strong></p>
<p>程序员都是懒惰的，不要想着等我完成了功能，再来优化代码的格式和结构，等真的把功能完成，很少有人会再愿意回头调整代码。</p>
<p><strong>4.2&nbsp;</strong><strong>使用</strong><strong>log</strong><strong>而不是</strong><strong>System.out.println()</strong></p>
<p>log可以设定级别，可以控制输出到哪里，容易区分是在代码的什么地方打印的，而System.out.print则不行。而且，System.out.print的速度很慢。所以，除非是有意的，否则，都要用log。至少在提交到svn之前把System.out.print换成log。</p>
<p><strong>4.3&nbsp;</strong><strong>每个</strong><strong>if while for</strong><strong>等语句，都不要省略大括号</strong><strong>{}</strong></p>
<p>看下面的代码：</p>
<p><strong>if</strong>&nbsp;(a&nbsp;&gt;&nbsp;b)</p>
<p>a++;</p>
<p>如果在以后维护的时候，需要在a &gt; b&nbsp;时，把b++，一步小心就会写成：</p>
<p><strong>if</strong>&nbsp;(a&nbsp;&gt;&nbsp;b)</p>
<p>a++;</p>
<p>b++;</p>
<p>这样就错了，因为无论a和b是什么关系，b++都会执行。&nbsp;如果一开始就这样写：</p>
<p><strong>if</strong>&nbsp;(a&nbsp;&gt;&nbsp;b)&nbsp;&nbsp;{</p>
<p>a++;</p>
<p>}</p>
<p>相信没有哪个笨蛋会把b++添加错的。而且，这个大括号使作用范围更明显，尤其是后面那行很长要折行时。</p>
<p><strong>4.4&nbsp;</strong><strong>善用</strong><strong>TODO:</strong></p>
<p>在代码中加入&nbsp;//TODO:&nbsp;，大部分的ide都会帮你提示，让你知道你还有什么事没有做。比如：</p>
<p><strong>if</strong>&nbsp;(order.isPaid())&nbsp;{</p>
<p><em>//TODO:&nbsp;</em><em>更新订单</em></p>
<p>}</p>
<p><strong>4.5&nbsp;</strong><strong>在需要留空的地方放一个空语句或注释，告述读者，你是故意的</strong></p>
<p>比如：</p>
<p><strong>if</strong>&nbsp;(!exists(order))&nbsp;{</p>
<p>;</p>
<p>}</p>
<p>或：</p>
<p><strong>if</strong>&nbsp;(!exists(order))&nbsp;{</p>
<p><em>//nothing to do</em></p>
<p>}</p>
<p><strong>4.6&nbsp;</strong><strong>不要再对</strong><strong>boolean</strong><strong>值做</strong><strong>true false</strong><strong>判断</strong></p>
<p>比如：</p>
<p><strong>if</strong>&nbsp;(order.isPaid()&nbsp;==&nbsp;<strong>true</strong>)&nbsp;{</p>
<p><em>// Do something here</em></p>
<p>}</p>
<p>不如写成：</p>
<p><strong>if</strong>&nbsp;(order.isPaid())&nbsp;{</p>
<p><em>//Do something here</em></p>
<p>}</p>
<p>后者读起来就很是&nbsp;if order is paid, &hellip;.&nbsp;要比&nbsp;if order&rsquo;s isPaid method returns true, &hellip;&nbsp;更容易理解</p>
<p><strong>4.7&nbsp;</strong><strong>减少代码嵌套层次</strong></p>
<p>代码嵌套层次达3层以上时，一般人理解起来都会困难。下面的代码是一个简单的例子：</p>
<p><strong>public</strong>&nbsp;<strong>void</strong>&nbsp;demo(<strong>int</strong>&nbsp;a,&nbsp;<strong>int</strong>&nbsp;b,&nbsp;<strong>int</strong>&nbsp;c)&nbsp;{</p>
<p><strong>if</strong>&nbsp;(a&nbsp;&gt;&nbsp;b)&nbsp;{</p>
<p><strong>if</strong>&nbsp;(b&nbsp;&gt;&nbsp;c)&nbsp;{</p>
<p>doJobA();</p>
<p>}&nbsp;<strong>else</strong>&nbsp;<strong>if</strong>&nbsp;(b&nbsp;&lt;&nbsp;c)&nbsp;{</p>
<p>doJobB()</p>
<p>}</p>
<p>}&nbsp;<strong>else</strong>&nbsp;{</p>
<p><strong>if</strong>&nbsp;(b&nbsp;&gt;&nbsp;c)&nbsp;{</p>
<p><strong>if</strong>&nbsp;(a&nbsp;&lt;&nbsp;c)&nbsp;{</p>
<p>doJobC();</p>
<p>}</p>
<p>}</p>
<p>}</p>
<p>}</p>
<p>减少嵌套的方法有很多：</p>
<ul><li>合并条件</li>
<li>利用&nbsp;return&nbsp;以省略后面的else</li>
<li>利用子方法</li></ul>
<p>比如上例，合并条件后成为：</p>
<p><strong>public</strong>&nbsp;<strong>void</strong>&nbsp;demo(<strong>int</strong>&nbsp;a,&nbsp;<strong>int</strong>&nbsp;b,&nbsp;<strong>int</strong>&nbsp;c)&nbsp;{</p>
<p><strong>if</strong>&nbsp;(a&nbsp;&gt;&nbsp;b&nbsp;&amp;&amp;&nbsp;b&nbsp;&gt;&nbsp;c)&nbsp;{</p>
<p>doJobA();</p>
<p>}</p>
<p><strong>if</strong>&nbsp;(a&nbsp;&gt;&nbsp;b&nbsp;&amp;&amp;&nbsp;c&nbsp;&gt;&nbsp;b)&nbsp;{</p>
<p>doJobB();</p>
<p>}</p>
<p><strong>if</strong>&nbsp;(a&nbsp;&lt;=&nbsp;b&nbsp;&amp;&amp;&nbsp;c&nbsp;&lt;&nbsp;b&nbsp;&amp;&amp;&nbsp;a&nbsp;&lt;&nbsp;c)&nbsp;{</p>
<p>doJobC();</p>
<p>}</p>
<p>}</p>
<p>如果利用return&nbsp;则成为：</p>
<p><strong>public</strong>&nbsp;<strong>void</strong>&nbsp;demo(<strong>int</strong>&nbsp;a,&nbsp;<strong>int</strong>&nbsp;b,&nbsp;<strong>int</strong>&nbsp;c)&nbsp;{</p>
<p><strong>if</strong>&nbsp;(a&nbsp;&gt;&nbsp;b)&nbsp;{</p>
<p><strong>if</strong>&nbsp;(b&nbsp;&gt;&nbsp;c)&nbsp;{</p>
<p>doJobA();</p>
<p><strong>return</strong>;</p>
<p>}</p>
<p>doJobB()</p>
<p><strong>return</strong>;</p>
<p>}</p>
<p><strong>if</strong>&nbsp;(b&nbsp;&gt;&nbsp;c)&nbsp;{</p>
<p><strong>if</strong>&nbsp;(a&nbsp;&lt;&nbsp;c)&nbsp;{</p>
<p>doJobC();</p>
<p>}</p>
<p>}</p>
<p>}</p>
<p>利用子方法，就是将嵌套的程序提取出来放到另外的方法里。</p>
<p><strong>4.8&nbsp;</strong><strong>程序职责单一</strong></p>
<p>关注点分离是软件开发的真理。人类自所以能够完成复杂的工作，就是因为人类能够将工作分解到较小级别的任务上，在做每个任务时关注更少的东西。让程序单元的职责单一，可以使你在编写这段程序时关注更少的东西，从而降低难度，减少出错。</p>
<p><strong>4.9&nbsp;</strong><strong>变量的声明，初始化和被使用尽量放到一起</strong></p>
<p>比方说如下代码：</p>
<p><strong>int</strong>&nbsp;orderNum=&nbsp;getOrderNum();</p>
<p><em>//do something withou orderNum here</em></p>
<p>call(orderNum);</p>
<p>上例中的注释处代表了一段和orderNum不相关的代码。orderNum的声明和初始化离被使用的地方相隔了很多行的代码，这样做不好，不如这样：</p>
<p><em>//do something withou orderNum here</em></p>
<p><strong>int</strong>&nbsp;orderNum=&nbsp;getOrderNum();</p>
<p>call(orderNum);</p>
<p><strong>4.10&nbsp;</strong><strong>缩小变量的作用域</strong></p>
<p>能用局部变量的，不要使用实例变量，能用实例变量的，不要使用类变量。变量的生存期越短，以为着它被误用的机会越小，同一时刻程序员要关注的变量的状态越少。实例变量和类变量默认都不是线程安全的，局部变量是线程安全的。比如如下代码：</p>
<p><strong>public</strong>&nbsp;<strong>class</strong>&nbsp;OrderPayAction{</p>
<p><strong>private</strong>&nbsp;Order order;</p>
<p><strong>public</strong>&nbsp;<strong>void</strong>&nbsp;doAction()&nbsp;{</p>
<p>order&nbsp;=&nbsp;orderDao.findOrder();</p>
<p>doJob1();</p>
<p>doJob2();</p>
<p>}</p>
<p><strong>private</strong>&nbsp;<strong>void</strong>&nbsp;doJob1()&nbsp;{</p>
<p>doSomething(order);</p>
<p>}</p>
<p><strong>private</strong>&nbsp;<strong>void</strong>&nbsp;doJob2()&nbsp;{</p>
<p>doOtherThing(order);</p>
<p>}</p>
<p>}</p>
<p>上例中order只不过担当了在方法间传递参数之用，用下面的方法更好：</p>
<p><strong>public</strong>&nbsp;<strong>class</strong>&nbsp;OrderPayAction{</p>
<p><strong>public</strong>&nbsp;<strong>void</strong>&nbsp;doAction()&nbsp;{</p>
<p>order&nbsp;=&nbsp;orderDao.findOrder();</p>
<p>doJob1(order);</p>
<p>doJob2(order);</p>
<p>}</p>
<p><strong>private</strong>&nbsp;<strong>void</strong>&nbsp;doJob1(Order order)&nbsp;{</p>
<p>doSomething(order);</p>
<p>}</p>
<p><strong>private</strong>&nbsp;<strong>void</strong>&nbsp;doJob2(Order order)&nbsp;{</p>
<p>doOtherThing(order);</p>
<p>}</p>
<p>}</p>
<p><strong>4.11&nbsp;</strong><strong>尽量不要用参数来带回方法运算结果</strong></p>
<p>比如：</p>
<p><strong>public</strong>&nbsp;<strong>void</strong>&nbsp;calculate(Order order)&nbsp;{</p>
<p><strong>int</strong>&nbsp;result&nbsp;=&nbsp;0;</p>
<p><em>//do lots of computing and store it in the result</em></p>
<p>order.setResult(result);</p>
<p>}</p>
<p><strong>public</strong>&nbsp;<strong>void</strong>&nbsp;action()&nbsp;{</p>
<p>order&nbsp;=&nbsp;orderDao.findOrder();</p>
<p>calculate(order);</p>
<p><em>// do lots of things about order</em></p>
<p>}</p>
<p>例子中calculate方法通过传入的order对象来存储结果，&nbsp;不如如下写：</p>
<p><strong>public</strong>&nbsp;<strong>int</strong>&nbsp;calculate(Order order)&nbsp;{</p>
<p><strong>int</strong>&nbsp;result&nbsp;=&nbsp;0;</p>
<p><em>//do lots of computing and store it in the result</em></p>
<p><strong>return</strong>&nbsp;result;</p>
<p>}</p>
<p><strong>public</strong>&nbsp;<strong>void</strong>&nbsp;action()&nbsp;{</p>
<p>order&nbsp;=&nbsp;orderDao.findOrder();</p>
<p>order.setResult(calculate(order));</p>
<p><em>// do lots of things about order</em></p>
<p>}</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/2q70kk18.html">JavaScript实战-菜单特效</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kl2d7q.html">MS Project 使用之创建项目信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvgmg1q.html">POJ 1039问题描述</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zk1d49.html">DRL之：策略梯度方法　（Policy Gradient Methods）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mdmnkq.html">Uva 10881 Piotr&amp;rsquo&semi;s Ants 蚂蚁</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okpxg59.html">Microsoft HoloLens 技术解谜（下）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oke54x9.html">转：史上最全最强SpringMVC详细示例实战教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde2zn09.html">sql server 2008 在安装了活动目录以后无法启动服务了</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1vvyx9.html">Kafka笔记--分布式环境搭建</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnj1l5k8.html">python转换时间戳和日期时间格式的转换</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpwdz7q.html">OC的构造方法与分类知识点总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgnxrm8.html">为什么PHP（CLI）同一个错误信息会打印两次？</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me0w70q.html">ASP&period;NET Core RSA加密或解密</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojxzdpq.html">Deep Convolution Auto-encoder</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj1ovj9.html">React相关&colon;npm&comma;ES6&comma;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdo5pd9.html">Dubbo优雅关机原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rlyj68.html">JS冲刺</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwveyd8.html">axure工具的使用总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwoxkk8.html">ReactiveCocoa&lpar;III&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jxmenq.html">绩效沟通-BEST原则</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/m8zexpd8.html">Java的堆（Heap）和栈（Stack）的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxzjkz8.html">Python程序员的进化史</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlpdl69.html">第 15 章 CSS 文本样式&lbrack;上&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8olp718.html">通过angularJS官方案例快速入门</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rkl6rq.html">ubuntu 下安装memcache  以及php扩展</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq431r38.html">Js 风骚的代码</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zenvv8.html">&period;NET删除字节数组中的0字节</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96zrjyq.html">java对cookie的操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/0qw4gmz8.html">js的几种数据类型</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mr53p9.html">treeview bootstrap 多级下拉树</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
